﻿using Kivii.Finances.Seeyon.Entities;
using Kivii.Finances.Seeyon.Extensions;
using Kivii.Web;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Seeyon
{
    public class OaDepartIncomeUpload : RestfulExecution<OaDepartIncome>
    {
        public List<OaDepartIncome> Items { get; set; }

        public string loginName { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            var client = new JsonServiceClient(Configs.BaseUrl);
            var token = client.RequestRestToken(loginName);
            var reps = client.RequestUploadFormXml(Items, loginName, token);
            var rtns = new RestfulExecutionResponse<string>();
            rtns.Results = new List<string>();

            rtns.Results.Add(reps);
            return rtns;
        }
    }

    public class ContractGetFromOa : RestfulExecution<Contract>
    {
        public RequestOaContract Item { get; set; }

        public string loginName { get; set; }

        public override object OnExecution(IRequest req, IResponse res)
        {
            var client = new JsonServiceClient(Configs.BaseUrl);
            var token = client.RequestRestToken(loginName);
            var reps = client.RequestGetOaContract(Item, token);
            var rtns = new RestfulQueryResponse<Contract>();
            rtns.Results = new List<Contract>();

            foreach (var item in reps.data.data.data)
            {
                var oaData = item.masterData;
                var rtn = new Contract();
                rtn.ContractNumber = oaData.Field0063.showValue;
                rtn.SerialNumber = oaData.Field0081.showValue;
                rtn.Year = oaData.Field0080.showValue;
                rtn.Field0060 = oaData.Field0060.showValue;
                rtn.Field0062 = oaData.Field0062.showValue;
                rtn.ApplierName = oaData.Field0059.showValue;
                rtn.ApplyTime = oaData.Field0043.showValue;
                rtn.ApplyDepart = oaData.Field0078.showValue;
                rtn.DepartCode = oaData.Field0079.showValue;
                rtn.DepartmentName = oaData.Field0096.showValue;
                rtn.DepartmentCode = oaData.Field0097.showValue;
                rtn.Field0084 = oaData.Field0084.showValue;
                rtn.Field0083 = oaData.Field0083.showValue;
                rtn.Name = oaData.Field0001.showValue;
                rtn.Field0058 = oaData.Field0058.showValue;
                rtn.DepartmentTest = oaData.Field0002.showValue;
                rtn.LeaderName = oaData.Field0003.showValue;
                rtn.CustomerName = oaData.Field0004.showValue;
                rtn.CustomerAddress = oaData.Field0005.showValue;
                rtn.CustomerLeaderName = oaData.Field0006.showValue;
                rtn.CustomerTax = oaData.Field0007.showValue;
                rtn.CustomerContactName = oaData.Field0008.showValue;
                rtn.CustomerContactNumber = oaData.Field0009.showValue;
                rtn.PayerName = oaData.Field0048.showValue;
                rtn.Type = oaData.Field0011.showValue;
                rtn.Field0072 = oaData.Field0072.showValue;
                rtn.AgreeYear = oaData.Field0012.showValue;
                rtn.AgreeBeginTime = oaData.Field0045.showValue;
                rtn.AgreeEndTime = oaData.Field0046.showValue;
                rtn.RateText = oaData.Field0014.showValue;
                rtn.Rate = oaData.Field0019.showValue;
                rtn.AgreeType = oaData.Field0015.showValue;
                rtn.Remark = oaData.Field0017.showValue;
                rtn.Amount = oaData.Field0020.showValue;
                rtn.PayType = oaData.Field0022.showValue;
                rtn.AmountFirstPay = oaData.Field0023.showValue;
                rtn.Quantity = oaData.Field0033.showValue;
                rtn.LimsNumber = oaData.Field0085.showValue;
                rtn.Field0064 = oaData.Field0064.showValue;
                rtn.FirstPayTime = oaData.Field0070.showValue;
                rtn.Field0074 = oaData.Field0074.showValue;
                rtn.StampTime = oaData.Field0089.showValue;
                rtns.Results.Add(rtn);
            }

            rtns.Total = rtns.Results.Count;
            return rtns;
        }
    }
}
